(   Title:  Enhanced error display for bntester
     File:  frtester-errors.fs
   Author:  David N. Williams
  License:  Public Domain
  Version:  1.5.0
  Started:  March 26, 2011
  Revised:  March 26, 2011

)

VARIABLE FRT-#ERRORS    0 FRT-#ERRORS !
: FRT-ERROR1  ( c-addr u -- )
\ Display an error message followed by the line that had the
\ error.
  red-text 1 FRT-#ERRORS +! FRT-ERROR-DEFAULT normal-text ;
\ ' FRT-ERROR1 FRT-ERROR-XT !

\ display results and goals
: frt-a.  ( 'array c-addr u -- )
  blue-text type
  ( 'array) dup >r @ dup
  IF   1- r> cell+ swap cells over +  \ display deepest first
       DO i fr@ fr. space -1 cells +LOOP
  ELSE r> 2drop ." none" THEN cr normal-text ;

: FRT-ERROR2  ( c-addr u -- )
  FRT-ERROR1
  frt-results s"  frresults: " frt-a.
  frt-goals   s"    frgoals: " frt-a. ;
\ ' FRT-ERROR2 FRT-ERROR-XT !

\ fancy results and goals display
: frt-fancy-a.  ( 'array c-addr u -- )
  blue-text type
  ( 'array) dup @ swap cell+ swap ?dup
  IF   ( n) 1- 0 swap  \ display deepest first
       DO ( 'elem) i cells over + fr@
          i frt-error-index @ =
          IF red-text fr. blue-text ELSE fr. THEN space
       -1 +LOOP
  ELSE ." none" THEN drop cr normal-text ;

: FRT-ERROR3  ( c-addr u -- )
  FRT-ERROR1
  frt-results s"  frresults: " frt-fancy-a.
  frt-goals   s"    frgoals: " frt-fancy-a. ;
' FRT-ERROR3 FRT-ERROR-XT !

: ?.frt-errors  ( -- )
  VERBOSE @ IF
  blue-text ." FRT-ERRORS: " normal-text FRT-#ERRORS @ . THEN ;
